Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -31,12 +31,13 @@
  * THE POSSIBILITY OF SUCH DAMAGE.
  */
-
 /** \file     TypeDef.h
     \brief    Define basic types, new types and enumerations
 */
-
-#ifndef _TYPEDEF__
-#define _TYPEDEF__
-
+#ifndef __TYPEDEF__
+#define __TYPEDEF__
+#ifndef __COMMONDEF__
+#error Include CommonDef.h not TypeDef.h
+#endif
+#include <vector>
 //! \ingroup TLibCommon
 //! \{
@@ -44,32 +45,28 @@
 ///////////////////////////////// EXTENSION SELECTION ///////////////////////////////////  
 /////////////////////////////////////////////////////////////////////////////////////////
-
 /* HEVC_EXT might be defined by compiler/makefile options.
-   
    Linux makefiles support the following settings:   
    make             -> HEVC_EXT not defined    
-   make HEVC_EXT=0  -> H_MV=0 H_3D=0   --> plain HM
-   make HEVC_EXT=1  -> H_MV=1 H_3D=0   --> MV only 
-   make HEVC_EXT=2  -> H_MV=1 H_3D=1   --> full 3D 
+   make HEVC_EXT=0  -> NH_MV=0 H_3D=0   --> plain HM
+   make HEVC_EXT=1  -> NH_MV=1 H_3D=0   --> MV only 
+   make HEVC_EXT=2  -> NH_MV=1 H_3D=1   --> full 3D 
 */
-
 #ifndef HEVC_EXT
-#define HEVC_EXT                    2
-#endif
-
+#define HEVC_EXT                    1
+#endif
 #if ( HEVC_EXT < 0 )||( HEVC_EXT > 2 )
 #error HEVC_EXT must be in the range of 0 to 2, inclusive. 
 #endif
-
-#define H_MV          ( HEVC_EXT != 0)
-#define H_3D          ( HEVC_EXT == 2)
-
+#define NH_MV          ( HEVC_EXT != 0)
+#define NH_3D          ( HEVC_EXT == 2)
 
 /////////////////////////////////////////////////////////////////////////////////////////
 ///////////////////////////////////   MAJOR DEFINES   ///////////////////////////////////  
 /////////////////////////////////////////////////////////////////////////////////////////
+#if NH_MV
+#define H_MV_ENC_DEC_TRAC                 1  //< CU/PU level tracking
 
-#if H_MV
-#define H_MV_ENC_DEC_TRAC                 1  //< CU/PU level tracking
+#if NH_3D
+#define NH_3D_VSO                         1
 #endif
 
@@ -78,5 +75,4 @@
                                               // HHI_QTLPC_RAU_OFF_C0160 JCT3V-C0160 change 2: quadtree limitation and predictive coding switched off in random access units 
                                               // MTK_TEX_DEP_PAR_G0055 Texture-partition-dependent depth partition. JCT3V-G0055
-
 #define H_3D_VSO                          1   // VSO, View synthesis optimization, includes: 
                                               // HHI_VSO
@@ -101,5 +97,4 @@
                                               // MTK_TEXTURE_MRGCAND_BUGFIX_E0182  Bug fix for TEXTURE MERGING CANDIDATE     , JCT3V-E0182
                                               // LGE_SIMP_DISP_AVAIL_J0041    // Use 2 status for disparity availability - DISP_AVAILABLE and DISP_NONE
-
 #define H_3D_ARP                          1   // Advanced residual prediction (ARP), JCT3V-D0177
                                               // QC_MTK_INTERVIEW_ARP_F0123_F0108 JCT3V-F0123; JCT3V-F0108
@@ -114,5 +109,4 @@
                                               // SEC_ARP_VIEW_REF_CHECK_J0037    Signaling iv_res_pred_weight_idx when the current slice has both view and temporal reference picture(s), JCT3V-J0037 item1
                                               // SEC_ARP_REM_ENC_RESTRICT_K0035    Removal of encoder restriction of ARP, JCT3V-K0035
-
 #define H_3D_IC                           1   // Illumination Compensation, JCT3V-B0045, JCT3V-C0046, JCT3V-D0060
                                               // Unifying rounding offset, for IC part, JCT3V-D0135
@@ -128,5 +122,4 @@
                                               // SEC_IC_NEIGHBOR_CLIP_I0080    // Clipping of neighboring sample position, JCT3V-I0080
                                               // LGE_CHROMA_IC_J0050_J0034
-
 #if H_3D_NBDV
 #define H_3D_NBDV_REF                     1   // Depth oriented neighboring block disparity derivation
@@ -138,5 +131,4 @@
                                               // SEC_VER_DONBDV_H0103          Vertical DV Restriction for DoNBDV
 #endif
-
 #define H_3D_VSP                          1   // View synthesis prediction
                                               // MERL_C0152: Basic VSP
@@ -157,7 +149,4 @@
                                               // MTK_MRG_LIST_SIZE_CLEANUP_J0059   1   // Include VSP for deriving merge candidate list size, JCT3V-J0059
                                               // SEC_A1_BASED_VSP_J0039            1   // Removal of redundant VSP in Merge list
-
-
-
 #define H_3D_IV_MERGE                     1   // Inter-view motion merge candidate
                                               // HHI_INTER_VIEW_MOTION_PRED 
@@ -183,11 +172,7 @@
                                               // SEC_SIMP_SHIFTED_DV_I0086     Simplification of Shifted DV candidate, JCT3V-I0086
                                               // SEC_SHIFTED_IVMC_POS_K0036    Position Derivation for Shifted-IVMC, JCT3V-K0036
-
-
 #define H_3D_TMVP                         1   // QC_TMVP_C0047 
                                               // Sony_M23639
                                               // H_3D_TMVP_SCALING_FIX_K0053       1   // QC/CY for K0053
-
-
 #define H_3D_DIM                          1   // DIM, Depth intra modes, includes:
                                               // HHI_DMM_WEDGE_INTRA
@@ -238,10 +223,7 @@
                                               // SHARP_DLT_SIMP_J0029 DLT(DepthValue2Idx[]) table derivation cleanup
                                               // SHARP_DMM_CLEAN_K0042             1   // Generate DMM pattern with rotation 
-
-
 #define H_3D_INTER_SDC                    1   // INTER SDC, Inter simplified depth coding
                                               // LGE_INTER_SDC_E0156 Enable inter SDC for depth coding
                                               // SEC_INTER_SDC_G0101 Improved inter SDC with multiple DC candidates
-
 #define H_3D_SPIVMP                       1   // H_3D_SPIVMP JCT3V-F0110: Sub-PU level inter-view motion prediction
                                               // SEC_SPIVMP_MCP_SIZE_G0077, Apply SPIVMP only to 2Nx2N partition, JCT3V-G0077
@@ -249,5 +231,4 @@
                                               // Simplification on Sub-PU level temporal interview motion prediction
                                               // MPI_SUBPU_DEFAULT_MV_H0077_H0099_H0111_H0133
-
 #define H_3D_DBBP                         1   // DBBP: Depth-based Block Partitioning and Merging
                                               // MTK_DBBP_AMP_REM_H0072   
@@ -263,18 +244,12 @@
                                               // RWTH_DBBP_NO_SATD_K0028
                                               // HS_DBBP_CLEAN_K0048
-
 #define H_3D_DDD                          1   // Disparity derived depth coding
                                               // LGE_DDD_REMOVAL_J0042_J0030 DDD removal
-
 #define H_3D_DIS                          1   // Depth intra skip 
                                               // SEC_DEPTH_INTRA_SKIP_MODE_K0033  Depth intra skip mode
-
 #define H_3D_FCO                          0   // Flexible coding order for 3D
-
 #define H_3D_FAST_INTRA_SDC               1   // I0123
-
 // OTHERS
                                               // MTK_SONY_PROGRESSIVE_MV_COMPRESSION_E0170 // Progressive MV Compression, JCT3V-E0170
-
 #define H_3D_FAST_TEXTURE_ENCODING        1   // Fast merge mode decision and early CU determination for texture component of dependent view, JCT3V-E0173
                                               // MTK_FAST_TEXTURE_ENCODING_E0173
@@ -283,5 +258,4 @@
                                               // SCU_HS_FAST_DEPTH_INTRA_E0238_HHIFIX
 #endif
-
 //HLS
                                              // HHI_DEPENDENCY_SIGNALLING_I1_J0107
@@ -292,5 +266,4 @@
                                              // HHI_CAM_PARA_K0052       
                                              // H_3D_DIRECT_DEP_TYPE     
-
 // Rate Control
 #define KWU_FIX_URQ                       1
@@ -298,17 +271,13 @@
 #define KWU_RC_MADPRED_E0227              0  ///< JCT3V-E0227, inter-view MAD prediction
 #endif // H_3D
-
 /////////////////////////////////////////////////////////////////////////////////////////
 ///////////////////////////////////   DERIVED DEFINES ///////////////////////////////////  
 /////////////////////////////////////////////////////////////////////////////////////////
-
-#if H_3D
-#define H_3D_DISABLE_CHROMA                    1 
+#if NH_3D
 #define H_3D_OUTPUT_ACTIVE_TOOLS               0
 #define H_3D_REN_MAX_DEV_OUT                   0
 #endif
-
 ///// ***** VIEW SYNTHESIS OPTIMIZAION *********
-#if H_3D_VSO                                  
+#if NH_3D_VSO                                  
 #define H_3D_VSO_DIST_INT                 1   // Allow negative synthesized view distortion change
 #define H_3D_VSO_COLOR_PLANES             1   // Compute VSO distortion on color planes 
@@ -317,5 +286,4 @@
 #define H_3D_VSO_SYNTH_DIST_OUT           0   // Output of synthesized view distortion instead of depth distortion in encoder output
 #endif
-
 ////   ****** NEIGHBOURING BLOCK-BASED DISPARITY VECTOR  *********
 #if H_3D_NBDV
@@ -324,10 +292,8 @@
 #define IDV_CANDS                         2
 #endif
-
 ///// ***** ADVANCED INTERVIEW RESIDUAL PREDICTION *********
 #if H_3D_ARP
 #define H_3D_ARP_WFNR                     3
 #endif
-
 ///// ***** DEPTH INTRA MODES *********
 #if H_3D_DIM
@@ -336,10 +302,11 @@
 #define H_3D_DIM_SDC                      1   // Simplified Depth Coding method
 #define H_3D_DIM_DLT                      1   // Depth Lookup Table
-
 #define H_3D_DIM_ENC                      1   // Depth Intra encoder optimizations, includes:
                                               // HHI_DEPTH_INTRA_SEARCH_RAU_C0160
                                               // LG_ZEROINTRADEPTHRESI_A0087
-
-#endif
+#endif
+/////////////////////////////////////////////////////////////////////////////////////
+/// GT: Move values which are not flags to CommonDef.h and convert to static int !!
+///////////////////////////////////////////////////////////////////////////////////
 ///// ***** VIEW SYNTHESIS PREDICTION *********
 #if H_3D_VSP
@@ -351,6 +318,4 @@
 #endif
 #endif
-
-
 ///// ***** ILLUMATION COMPENSATION *********
 #if H_3D_IC
@@ -360,6 +325,4 @@
 #define IC_LOW_LATENCY_ENCODING_THRESHOLD 0.1 // Threshold for low-latency IC encoding in JCT3V-H0086
 #endif
-
-
 ///// ***** DEPTH BASED BLOCK PARTITIONING *********
 #if H_3D_DBBP
@@ -367,6 +330,4 @@
 #define DBBP_PACK_MODE               SIZE_2NxN
 #endif
-
-
 ///// ***** FCO *********
 #if H_3D_FCO
@@ -375,24 +336,17 @@
 #define H_3D_FCO_VSP_DONBDV_E0163               0   // Adaptive depth reference for flexible coding order
 #endif
-
 #if H_3D
 #define PPS_FIX_DEPTH                           1
 #endif
-
-
 /////////////////////////////////////////////////////////////////////////////////
 ///////////////////////////////////   MV_HEVC HLS  //////////////////////////////
 /////////////////////////////////////////////////////////////////////////////////
 // TBD: Check if integration is necessary. 
-
-
 #define H_MV_HLS_PTL_LIMITS                  0
 #define H_MV_HLS7_GEN                        0  // General changes (not tested)
-
 // POC
 // #define H_MV_HLS_7_POC_P0041_3            0 // (POC/P0041/POC reset) #3 It was remarked that we should require each non-IRAP picture that has discardable_flag equal to 1 to have NUT value indicating that it is a sub-layer non-reference picture. This was agreed. Decision: Adopt (with constraint for discardable_flag as described above) 
 // #define H_MV_HLS_7_POC_P0041_FIXES        0 // (POC/P0041/Fixes) For each non-IRAP picture that has discardable_flag equal to 1 to have NUT value indicating that it is a sub-layer non-reference picture. 
 // #define H_MV_HLS_7_POC_P0056_4            0 // (POC/P0056/layer tree poc) #4 Proposal 1: If the POC reset approach is adopted as the basis for multi-layer POC derivation, it is proposed to derive the POC anchor picture from the previous TID0 picture (that is not a RASL picture, a RADL picture or a sub-layer non-reference picture and not with discardable_flag equal to 1) of  the current layer or any of its reference layer. This is asserted to improve loss resilience and reduce bit rate overhead. Decision: Adopt Proposal 1 (with the suggested modifications Ewith text provided as P0297).
-
 // SEI related
 //#define H_MV_HLS_8_SEI_NODOC_53  0 // #53 (SEI    /NODOC/Added Multiview view position SEI message) Plain copy from AVC.
@@ -409,5 +363,4 @@
 //#define H_MV_HLS_7_SEI_P0133_28  0 // (SEI/P0133/Recovery point SEI) #28 Decision: Adopt change to recover point semantics only (-v3)
 //#define H_MV_HLS_7_SEI_P0123_25  0 // (SEI/P0123/Alpha channel info) #25 Add alpha channel information SEI message Decision: Adopt. Constrain the bit depth indicated to be equal to the coded bit depth of the aux picture. 
-
 // DPB
 //#define H_MV_HLS_8_HRD_Q0102_09  0 // #9  (HRD    /Q0102/NoOutputOfPriorPicsFlag) It was suggested that also the separate_colour_plane_flag should affect inference of NoOutputOfPriorPicsFlag. Decision (Ed.): Agreed (affects RExt text).
@@ -415,193 +368,110 @@
 //#define H_MV_HLS_8_HRD_Q0154_10  0 // #10 (HRD    /Q0154/DPB Flushing and parameters) On picture flushing and DPB parameters Decision: Adopted (some details to be discussed further in BoG).
 //#define H_MV_HLS_7_OTHER_P0187_1 0 // (OTHER/P0187/NoOutputOfPriorPicsFlag) #1 Inference of NoOutputOfPriorPicsFlag and proposes to take into account colour format and bit depth for the inference in addition to spatial resolution 
-
 // OTHERS
 //#define H_MV_HLS_8_HSB_Q0041_03  0 // #3  (HS     /Q0041/hybrid scalability) The proposed text was endorsed, with non-editorial open issues considered as follows ?// #define H_MV_HLS_7_OTHER_P0187_1          0 // (OTHER/P0187/NoOutputOfPriorPicsFlag) #1 Inference of NoOutputOfPriorPicsFlag and proposes to take into account colour format and bit depth for the inference in addition to spatial resolution 
 //#define H_MV_HLS_8_MIS_Q0078_24  0 // #24 (MISC   /Q0078/scan and pic type) , Items 3 b,c and 4, clarifying which pictures in an output layer sets are applied the values of general_progressive_source_flag, general_interlaced_source_flag, general_non_packed_constraint_flag and general_frame_only_constraint_flag.
 //#define H_MV_HLS_7_HRD_P0138_6   0 //     (HRD/P0138/HRD parameters for bitstreams excluding) #6 Decision: Adopt (as revised in updated contribution, with the specification of a flag in the BP SEI (HRD/P0192/sub-DPB) #12 Establish sub-DPBs based on the representation format indicated at the VPS level. It was suggested that the expressed shared capacity limit would need to be less than or equal to the sum of the individual capacity limits. Decision: Adopt as modified. Further study is encouraged on profile/level constraint selections. 
-
 /////////////////////////////////////////////////////////////////////////////////////////
 ///////////////////////////////////   HM RELATED DEFINES ////////////////////////////////
 /////////////////////////////////////////////////////////////////////////////////////////
-#define HARMONIZE_GOP_FIRST_FIELD_COUPLE  1
-#define FIX_FIELD_DEPTH                 1
-#if H_MV
-#define EFFICIENT_FIELD_IRAP            0
-#else
-#define EFFICIENT_FIELD_IRAP            1
-#endif
-#define ALLOW_RECOVERY_POINT_AS_RAP     1
-#define BUGFIX_INTRAPERIOD              1
-#define SAO_ENCODE_ALLOW_USE_PREDEBLOCK 1
-
-#define SAO_SGN_FUNC 1
-
-#define TILE_SIZE_CHECK 1
-
-#define FIX1172 1 ///< fix ticket #1172
-
-#define SETTING_PIC_OUTPUT_MARK     1
-#define SETTING_NO_OUT_PIC_PRIOR    1
-#define FIX_EMPTY_PAYLOAD_NAL       1
-#define FIX_WRITING_OUTPUT          1
-#define FIX_OUTPUT_EOS              1
-
-#define FIX_POC_CRA_NORASL_OUTPUT   1
-
-#define MAX_NUM_PICS_IN_SOP           1024
-
-#define MAX_NESTING_NUM_OPS         1024
-#define MAX_NESTING_NUM_LAYER       64
-
-#if H_MV
-#define MAX_VPS_NUM_HRD_PARAMETERS                1024
-#else
-#define MAX_VPS_NUM_HRD_PARAMETERS                1
-#endif
-#if H_MV
-#define MAX_NUM_SUB_LAYERS                        7
-#define MAX_NUM_SIGNALLED_PARTITIONING_SCHEMES    16
-#endif
-#define MAX_VPS_OP_SETS_PLUS1                     1024
-#if H_MV
-#define MAX_VPS_NUM_ADD_LAYER_SETS                1024
-#define MAX_VPS_NUH_LAYER_ID_PLUS1  63
-#define MAX_NUM_SCALABILITY_TYPES   16
-#define ENC_CFG_CONSOUT_SPACE       29           
-#else
-#define MAX_VPS_NUH_RESERVED_ZERO_LAYER_ID_PLUS1  1
-#endif
-
-
-#define MAX_CPB_CNT                     32  ///< Upper bound of (cpb_cnt_minus1 + 1)
-#if H_MV
-#define MAX_NUM_LAYER_IDS               63
-#define MAX_NUM_LAYERS                  63
-#define MAX_VPS_PROFILE_TIER_LEVEL      64
-#define MAX_VPS_ADD_OUTPUT_LAYER_SETS   1024
-#define MAX_VPS_OUTPUTLAYER_SETS        ( MAX_VPS_ADD_OUTPUT_LAYER_SETS + MAX_VPS_OP_SETS_PLUS1 + MAX_VPS_OP_SETS_PLUS1 )
-#define  MAX_NUM_VIDEO_SIGNAL_INFO      16
-#define MAX_NUM_SCALED_REF_LAYERS       MAX_NUM_LAYERS-1
-#else
-#define MAX_NUM_LAYER_IDS                64
-#endif
-
-#define COEF_REMAIN_BIN_REDUCTION        3 ///< indicates the level at which the VLC 
-                                           ///< transitions from Golomb-Rice to TU+EG(k)
-
-#define CU_DQP_TU_CMAX 5                   ///< max number bins for truncated unary
-#define CU_DQP_EG_k 0                      ///< expgolomb order
-
-#define SBH_THRESHOLD                    4  ///< I0156: value of the fixed SBH controlling threshold
-  
-#define SEQUENCE_LEVEL_LOSSLESS           0  ///< H0530: used only for sequence or frame-level lossless coding
-
-#define DISABLING_CLIP_FOR_BIPREDME         1  ///< Ticket #175
-  
-#define C1FLAG_NUMBER               8 // maximum number of largerThan1 flag coded in one chunk :  16 in HM5
-#define C2FLAG_NUMBER               1 // maximum number of largerThan2 flag coded in one chunk:  16 in HM5 
-#define SAO_ENCODING_CHOICE              1  ///< I0184: picture early termination
-#if SAO_ENCODING_CHOICE
-#define SAO_ENCODING_RATE                0.75
-#define SAO_ENCODING_CHOICE_CHROMA       1 ///< J0044: picture early termination Luma and Chroma are handled separately
-#if SAO_ENCODING_CHOICE_CHROMA
-#define SAO_ENCODING_RATE_CHROMA         0.5
-#endif
-#endif
-
-#define MAX_NUM_VPS                16
-#define MAX_NUM_SPS                16
-#define MAX_NUM_PPS                64
-
-#define RDOQ_CHROMA_LAMBDA          1   ///< F386: weighting of chroma for RDOQ
-
-#define MIN_SCAN_POS_CROSS          4
-
-#define FAST_BIT_EST                1   ///< G763: Table-based bit estimation for CABAC
-
-#define MLS_GRP_NUM                         64     ///< G644 : Max number of coefficient groups, max(16, 64)
-#define MLS_CG_SIZE                         4      ///< G644 : Coefficient group size of 4x4
-
-#define ADAPTIVE_QP_SELECTION               1      ///< G382: Adaptive reconstruction levels, non-normative part for adaptive QP selection
-#if ADAPTIVE_QP_SELECTION
-#define ARL_C_PRECISION                     7      ///< G382: 7-bit arithmetic precision
-#define LEVEL_RANGE                         30     ///< G382: max coefficient level in statistics collection
-#endif
-
-#define HHI_RQT_INTRA_SPEEDUP             1           ///< tests one best mode with full rqt
-#define HHI_RQT_INTRA_SPEEDUP_MOD         0           ///< tests two best modes with full rqt
-
+#endif
+// ====================================================================================================================
+// Debugging
+// ====================================================================================================================
+#define DEBUG_STRING                                      0 ///< When enabled, prints out final decision debug info at encoder and decoder
+#define DEBUG_ENCODER_SEARCH_BINS                         0 ///< When enabled, prints out each bin as it is coded during encoder search
+#define DEBUG_CABAC_BINS                                  0 ///< When enabled, prints out each bin as it is coded during final encode and decode
+#define DEBUG_INTRA_SEARCH_COSTS                          0 ///< When enabled, prints out the cost for each mode during encoder search
+#define DEBUG_TRANSFORM_AND_QUANTISE                      0 ///< When enabled, prints out each TU as it passes through the transform-quantise-dequantise-inverseTransform process
+#define ENVIRONMENT_VARIABLE_DEBUG_AND_TEST               0 ///< When enabled, allows control of debug modifications via environment variables
+#define PRINT_MACRO_VALUES                                1 ///< When enabled, the encoder prints out a list of the non-environment-variable controlled macros and their values on startup
+// TODO: rename this macro to DECODER_DEBUG_BIT_STATISTICS (may currently cause merge issues with other branches)
+// This can be enabled by the makefile
+#ifndef RExt__DECODER_DEBUG_BIT_STATISTICS
+#define RExt__DECODER_DEBUG_BIT_STATISTICS                0 ///< 0 (default) = decoder reports as normal, 1 = decoder produces bit usage statistics (will impact decoder run time by up to ~10%)
+#endif
+// This can be enabled by the makefile
+#if !NH_MV
+#ifndef ENC_DEC_TRACE
+#define ENC_DEC_TRACE                                     0
+#endif
+#endif
+#define DEC_NUH_TRACE                                     0 ///< When trace enabled, enable tracing of NAL unit headers at the decoder (currently not possible at the encoder)
+#define PRINT_RPS_INFO                                    0 ///< Enable/disable the printing of bits used to send the RPS.
+// ====================================================================================================================
+// Tool Switches - transitory (these macros are likely to be removed in future revisions)
+// ====================================================================================================================
+#define DECODER_CHECK_SUBSTREAM_AND_SLICE_TRAILING_BYTES  1 ///< TODO: integrate this macro into a broader conformance checking system.
+#define T0196_SELECTIVE_RDOQ                              1 ///< selective RDOQ
+// ====================================================================================================================
+// Tool Switches
+// ====================================================================================================================
+#define ADAPTIVE_QP_SELECTION                             1 ///< G382: Adaptive reconstruction levels, non-normative part for adaptive QP selection
+#define AMP_ENC_SPEEDUP                                   1 ///< encoder only speed-up by AMP mode skipping
+#if AMP_ENC_SPEEDUP
+#define AMP_MRG                                           1 ///< encoder only force merge for AMP partition (no motion search for AMP)
+#endif
+#define FAST_BIT_EST                                      1   ///< G763: Table-based bit estimation for CABAC
+#define HHI_RQT_INTRA_SPEEDUP                             1           ///< tests one best mode with full rqt
+#define HHI_RQT_INTRA_SPEEDUP_MOD                         0           ///< tests two best modes with full rqt
 #if HHI_RQT_INTRA_SPEEDUP_MOD && !HHI_RQT_INTRA_SPEEDUP
 #error
 #endif
-
-#define VERBOSE_RATE 0 ///< Print additional rate information in encoder
-
-#define AMVP_DECIMATION_FACTOR            4
-
-#define SCAN_SET_SIZE                     16
-#define LOG2_SCAN_SET_SIZE                4
-
-#define FAST_UDI_MAX_RDMODE_NUM               35          ///< maximum number of RD comparison in fast-UDI estimation loop 
-
-#define ZERO_MVD_EST                          0           ///< Zero Mvd Estimation in normal mode
-
-#define NUM_INTRA_MODE 36
-#if !REMOVE_LM_CHROMA
-#define LM_CHROMA_IDX  35
-#endif
-
-#define WRITE_BACK                      1           ///< Enable/disable the encoder to replace the deltaPOC and Used by current from the config file with the values derived by the refIdc parameter.
-#define AUTO_INTER_RPS                  1           ///< Enable/disable the automatic generation of refIdc from the deltaPOC and Used by current from the config file.
-#define PRINT_RPS_INFO                  0           ///< Enable/disable the printing of bits used to send the RPS.
-                                                    // using one nearest frame as reference frame, and the other frames are high quality (POC%4==0) frames (1+X)
-                                                    // this should be done with encoder only decision
-                                                    // but because of the absence of reference frame management, the related code was hard coded currently
-
-#define RVM_VCEGAM10_M 4
-
-#define PLANAR_IDX             0
-#define VER_IDX                26                    // index for intra VERTICAL   mode
-#define HOR_IDX                10                    // index for intra HORIZONTAL mode
-#define DC_IDX                 1                     // index for intra DC mode
-#define NUM_CHROMA_MODE        5                     // total number of chroma modes
-#define DM_CHROMA_IDX          36                    // chroma mode index for derived from luma intra mode
-
-
-#define FAST_UDI_USE_MPM 1
-
-#define RDO_WITHOUT_DQP_BITS              0           ///< Disable counting dQP bits in RDO-based mode decision
-
-#define FULL_NBIT 0 ///< When enabled, compute costs using full sample bitdepth.  When disabled, compute costs as if it is 8-bit source video.
+#define MATRIX_MULT                                       0 ///< Brute force matrix multiplication instead of partial butterfly
+#define O0043_BEST_EFFORT_DECODING                        0 ///< 0 (default) = disable code related to best effort decoding, 1 = enable code relating to best effort decoding [ decode-side only ].
+#define RDOQ_CHROMA_LAMBDA                                1 ///< F386: weighting of chroma for RDOQ
+// This can be enabled by the makefile
+#ifndef RExt__HIGH_BIT_DEPTH_SUPPORT
+#define RExt__HIGH_BIT_DEPTH_SUPPORT                                           0 ///< 0 (default) use data type definitions for 8-10 bit video, 1 = use larger data types to allow for up to 16-bit video (originally developed as part of N0188)
+#endif
+// ====================================================================================================================
+// Derived macros
+// ====================================================================================================================
+#if RExt__HIGH_BIT_DEPTH_SUPPORT
+#define FULL_NBIT                                                              1 ///< When enabled, use distortion measure derived from all bits of source data, otherwise discard (bitDepth - 8) least-significant bits of distortion
+#define RExt__HIGH_PRECISION_FORWARD_TRANSFORM                                 1 ///< 0 use original 6-bit transform matrices for both forward and inverse transform, 1 (default) = use original matrices for inverse transform and high precision matrices for forward transform
+#else
+#define FULL_NBIT                                                              0 ///< When enabled, use distortion measure derived from all bits of source data, otherwise discard (bitDepth - 8) least-significant bits of distortion
+#define RExt__HIGH_PRECISION_FORWARD_TRANSFORM                                 0 ///< 0 (default) use original 6-bit transform matrices for both forward and inverse transform, 1 = use original matrices for inverse transform and high precision matrices for forward transform
+#endif
 #if FULL_NBIT
-# define DISTORTION_PRECISION_ADJUSTMENT(x) 0
+# define DISTORTION_PRECISION_ADJUSTMENT(x)  0
 #else
 # define DISTORTION_PRECISION_ADJUSTMENT(x) (x)
 #endif
-
-#define LOG2_MAX_NUM_COLUMNS_MINUS1        7
-#define LOG2_MAX_NUM_ROWS_MINUS1           7
-#define LOG2_MAX_COLUMN_WIDTH              13
-#define LOG2_MAX_ROW_HEIGHT                13
-
-#define MATRIX_MULT                             0   // Brute force matrix multiplication instead of partial butterfly
-
-#define REG_DCT 65535
-
-#define AMP_SAD                               1           ///< dedicated SAD functions for AMP
-#define AMP_ENC_SPEEDUP                       1           ///< encoder only speed-up by AMP mode skipping
-#if AMP_ENC_SPEEDUP
-#define AMP_MRG                               1           ///< encoder only force merge for AMP partition (no motion search for AMP)
-#endif
-
-#define CABAC_INIT_PRESENT_FLAG     1
-
+#if DEBUG_STRING
+  #define DEBUG_STRING_PASS_INTO(name) , name
+  #define DEBUG_STRING_PASS_INTO_OPTIONAL(name, exp) , (exp==0)?0:name
+  #define DEBUG_STRING_FN_DECLARE(name) , std::string &name
+  #define DEBUG_STRING_FN_DECLAREP(name) , std::string *name
+  #define DEBUG_STRING_NEW(name) std::string name;
+  #define DEBUG_STRING_OUTPUT(os, name) os << name;
+  #define DEBUG_STRING_APPEND(str1, str2) str1+=str2;
+  #define DEBUG_STRING_SWAP(str1, str2) str1.swap(str2);
+  #define DEBUG_STRING_CHANNEL_CONDITION(compID) (true)
+  #include <sstream>
+  #include <iomanip>
+#else
+  #define DEBUG_STRING_PASS_INTO(name)
+  #define DEBUG_STRING_PASS_INTO_OPTIONAL(name, exp)
+  #define DEBUG_STRING_FN_DECLARE(name)
+  #define DEBUG_STRING_FN_DECLAREP(name)
+  #define DEBUG_STRING_NEW(name)
+  #define DEBUG_STRING_OUTPUT(os, name)
+  #define DEBUG_STRING_APPEND(str1, str2)
+  #define DEBUG_STRING_SWAP(srt1, str2)
+  #define DEBUG_STRING_CHANNEL_CONDITION(compID)
+#endif
+// ====================================================================================================================
+// Error checks
+// ====================================================================================================================
+#if ((RExt__HIGH_PRECISION_FORWARD_TRANSFORM != 0) && (RExt__HIGH_BIT_DEPTH_SUPPORT == 0))
+#error ERROR: cannot enable RExt__HIGH_PRECISION_FORWARD_TRANSFORM without RExt__HIGH_BIT_DEPTH_SUPPORT
+#endif
 // ====================================================================================================================
 // Basic type redefinition
 // ====================================================================================================================
-
 typedef       void                Void;
 typedef       bool                Bool;
-
 #ifdef __arm__
 typedef       signed char         Char;
@@ -616,12 +486,9 @@
 typedef       double              Double;
 typedef       float               Float;
-
 // ====================================================================================================================
 // 64-bit integer type
 // ====================================================================================================================
-
 #ifdef _MSC_VER
 typedef       __int64             Int64;
-
 #if _MSC_VER <= 1200 // MS VC6
 typedef       __int64             UInt64;   // MS VC6 does not support unsigned __int64 to double conversion
